Index: trunk/SophyaPI/PI/piaxestools.cc
===================================================================
--- trunk/SophyaPI/PI/piaxestools.cc	(revision 2182)
+++ trunk/SophyaPI/PI/piaxestools.cc	(revision 2184)
@@ -79,4 +79,5 @@
 {
 int bsx, bsy, spx, spy;
+int bsycb, spycb;
 
 // On definit la taille a partir de la taille par defaut des composantes 
@@ -86,9 +87,12 @@
 spy = bsy/4;
 
+bsycb = 0.80*bsy+0.5;  // Taille des checkbox
+spycb = 0.80*spy+0.5;  // Espace-Y inter checkbox
+
 int wszx = 6*spx+3.5*bsx; 
-int wszy = 8*bsy+10*spy;
+int wszy = 5*bsy+9*spy+4*bsycb+3*spycb;
 SetSize(wszx, wszy);
 
-int cpx = spx*2;
+int cpx = spx;
 int cpy = spy*2;
 mLab[0] = new PILabel(this, "X Min Max", 1.25*bsx, bsy, cpx, cpy);
@@ -99,38 +103,44 @@
 
 cpy = spy*2;
-cpx += 2*spx+1.25*bsx; 
-mText[0] = new PIText(this, "x_min_max", 2.25*bsx, bsy, cpx, cpy);
+cpx += spx+1.25*bsx; 
+mText[0] = new PIText(this, "x_min_max", 2.25*bsx+2*spx, bsy, cpx, cpy);
 mText[0]->SetText("-1.0  1.0");
 cpy += spy+bsy; 
-mText[1] = new PIText(this, "y_min_max", 2.25*bsx, bsy, cpx, cpy);
+mText[1] = new PIText(this, "y_min_max", 2.25*bsx+2*spx, bsy, cpx, cpy);
 mText[1]->SetText("-1.0  1.0");
 mText[0]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
 mText[1]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
 
-cpx = spx+0.25*bsx;
-cpy += spy+bsy;
-mCkb[0] = new PICheckBox(this,"X-RtoL", 2000, bsx, bsy, cpx, cpy);
-cpx += spx+bsx; 
-mCkb[1] = new PICheckBox(this,"Y-UpDn", 2001, bsx, bsy, cpx, cpy);
-cpx += spx+bsx; 
-mCkb[2] = new PICheckBox(this,"Grid", 2002, bsx, bsy, cpx, cpy);
+cpy += spy+bsy; 
+cpx = spx+0.25*bsx;
+mCkb[3] = new PICheckBox(this,"LogScale-X", 2003, bsx*1.5, bsycb, cpx, cpy);
+cpx += bsx*1.5+3*spx;
+mCkb[4] = new PICheckBox(this,"LogScale-Y", 2004, bsx*1.5, bsycb, cpx, cpy);
+mCkb[3]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
+mCkb[4]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
+
+cpx = spx+0.25*bsx;
+cpy += spycb+bsycb;
+mCkb[0] = new PICheckBox(this,"X-RightLeft", 2000, bsx*1.5, bsycb, cpx, cpy);
+cpx += bsx*1.5+3*spx;
+mCkb[1] = new PICheckBox(this,"Y-UpDn", 2001, bsx*1.5, bsycb, cpx, cpy);
 mCkb[0]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
 mCkb[1]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
+
+cpx = spx+0.25*bsx;
+cpy += spycb+bsycb;
+mCkb[5] = new PICheckBox(this,"Centerd-Axes", 2005, bsx*1.5, bsycb, cpx, cpy);
+cpx += bsx*1.5+3*spx;
+mCkb[2] = new PICheckBox(this,"Grid", 2002, bsx*1.5, bsycb, cpx, cpy);
+mCkb[5]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
 mCkb[2]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
-cpy += spy+bsy; 
-cpx = spx+0.25*bsx;
-mCkb[3] = new PICheckBox(this,"LogScale-X", 2003, bsx*1.5, bsy, cpx, cpy);
-cpx += bsx*1.5+3*spx;
-mCkb[4] = new PICheckBox(this,"LogScale-Y", 2004, bsx*1.5, bsy, cpx, cpy);
-mCkb[3]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
-mCkb[4]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
-
-cpx = spx+0.25*bsx;
-cpy += spy+bsy;
-mCkb[5] = new PICheckBox(this,"Centerd-Axes", 2005, 1.5*bsx, bsy, cpx, cpy);
+
+cpx = spx+0.25*bsx;
+cpy += spycb+bsycb;
+mCkb[6] = new PICheckBox(this,"Minor-Ticks", 2006, bsx*1.5, bsycb, cpx, cpy);
 cpx += 3*spx+1.5*bsx; 
-mCkb[6] = new PICheckBox(this,"Minor-Ticks", 2006, 1.5*bsx, bsy, cpx, cpy);
-mCkb[5]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
+mCkb[7] = new PICheckBox(this,"AutoFontSize", 2007, bsx*1.5, bsycb, cpx, cpy);
 mCkb[6]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
+mCkb[7]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
 
 
@@ -185,5 +195,5 @@
 for(i=0;i<2;i++) delete mText[i];
 for(i=0;i<8;i++) delete mBut[i];
-for(i=0;i<7;i++) delete mCkb[i];
+for(i=0;i<8;i++) delete mCkb[i];
 delete mOpt;
 }
@@ -226,4 +236,5 @@
   mCkb[3]->SetState(scd->isLogScaleX());
   mCkb[4]->SetState(scd->isLogScaleY());
+  mCkb[7]->SetState(scd->BaseDrawer()->isAxesAutoFontSize());
   }
 else {
@@ -235,4 +246,7 @@
   mCkb[3]->SetState(false);
   mCkb[4]->SetState(false);
+  mCkb[5]->SetState(false);
+  mCkb[6]->SetState(false);
+  mCkb[7]->SetState(true);
   }
 
@@ -297,5 +311,5 @@
 
   scd->SetLogScale(mCkb[3]->GetState(), mCkb[4]->GetState() );
-
+  scd->BaseDrawer()->SetAxesAutoFontSize(mCkb[7]->GetState() );
   if (refr) scd->Refresh();
   return;
Index: trunk/SophyaPI/PI/piaxestools.h
===================================================================
--- trunk/SophyaPI/PI/piaxestools.h	(revision 2182)
+++ trunk/SophyaPI/PI/piaxestools.h	(revision 2184)
@@ -40,5 +40,5 @@
   PIButton* mBut[8];
   PIText* mText[2];
-  PICheckBox* mCkb[7];
+  PICheckBox* mCkb[8];
   PIOptMenu * mOpt;
   unsigned short mTypAction;
Index: trunk/SophyaPI/PI/pidrawer.h
===================================================================
--- trunk/SophyaPI/PI/pidrawer.h	(revision 2182)
+++ trunk/SophyaPI/PI/pidrawer.h	(revision 2184)
@@ -55,5 +55,5 @@
 
   inline unsigned int GetAxesFlags() { return(axesFlags); }
-  inline  bool       isAxesAutoFontSize(bool fg=true) { return axesAFSz; }
+  inline  bool       isAxesAutoFontSize() { return axesAFSz; }
 
   inline PIGraphicUC*    GetGraphicUC() { return(mGrUC); }